unit uselect;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, WEBLib.Menus, WEBLib.StdCtrls, WEBLib.REST, WEBLib.Json;

type
  TForm1 = class(TWebForm)
    WebComboBox1: TWebComboBox;
    WebButton1: TWebButton;
    WebButton2: TWebButton;
    WebHTTPRequest1: TWebHTTPRequest;
    WebWaitMessage1: TWebWaitMessage;
    WebButton3: TWebButton;
    procedure Form1DOMContentLoaded(Sender: TObject);
    procedure Form1Create(Sender: TObject);
    procedure WebButton1Click(Sender: TObject);
    procedure WebButton2Click(Sender: TObject);
    procedure WebHTTPRequest1Error(Sender: TObject; ARequest: TJSXMLHttpRequestRecord; Event: TJSEventRecord; var Handled: boolean);
    procedure WebButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.WebButton3Click(Sender: TObject);
begin
 WebWaitMessage1.Show;

  WebHTTPRequest1.URL := 'https://jsonplaceholder.typicode.com/users/3';
  WebHTTPRequest1.Execute(
        procedure(AResponse: string; AReq: TJSXMLHttpRequest)
        var
           s: string;
           jo: TJSONObject;
           jpair: TJSONPair;

          i: integer;
          codigo : string;
        begin

          s     := AResponse;
          jo    := TJSONObject(TJSONObject.ParseJSONValue(s));
          jPair := jo.Get('id');
          codigo := jPair.JsonValue.ToString;
               

                  asm
                      var idDigitado = codigo; // Gets the entered ID
                                  $(".select-frutas").val(idDigitado).trigger("change"); // Select option based on ID

                                  //updates the label with the updated record as well
                                  $("#id-fruta-selecionada").text(idDigitado);
                  end;


            WebWaitMessage1.Hide;
              
        end
  );
 
end;

procedure TForm1.WebHTTPRequest1Error(Sender: TObject; ARequest: TJSXMLHttpRequestRecord; Event: TJSEventRecord; var Handled: boolean);
begin
  WebWaitMessage1.Hide;
end;

procedure TForm1.WebButton2Click(Sender: TObject);
begin
  WebWaitMessage1.Show;

  WebHTTPRequest1.URL := 'https://jsonplaceholder.typicode.com/users';
  WebHTTPRequest1.Execute(
        procedure(AResponse: string; AReq: TJSXMLHttpRequest)
        var
          js: TJSON;
          ja: TJSONArray;
          user: TJSONObject;
          i: integer;
        begin
           WebComboBox1.Items.Clear;
          
                js := TJSON.Create;
                try 
                  ja := TJSONArray(js. Parse(AResponse));

                  for i := 0 to ja.Count - 1 do
                  begin                  
                    user := TJSONObject(ja.Items[i]);                    
                    WebComboBox1.Items.Add(  Format('%s=%s',[user.GetJSONValue('name'), user.GetJSONValue('id')]) );

                  end;
                  WebWaitMessage1.Hide;
                finally
                  js.free;                  
                end;
        end
  );

end;

procedure TForm1.WebButton1Click(Sender: TObject);
begin
  asm
       var idDigitado = $("#input-id-fruta").val(); // Gets the entered ID
                  $(".select-frutas").val(idDigitado).trigger("change"); // Select option based on ID

                  //updates the label with the updated record as well
                  $("#id-fruta-selecionada").text(idDigitado);
  end;
end;

procedure TForm1.Form1Create(Sender: TObject);
begin
  asm
         // Captures the selection event in Select2 and displays the ID of the selected fruit
              $(".select-frutas").on("select2:select", function (e) {
                  var idFrutaSelecionada = e.params.data.id;
                  $("#id-fruta-selecionada").text(idFrutaSelecionada);

                  // throws the id field into the input also when selecting
                  $("#input-id-fruta").val(idFrutaSelecionada);
              });             

  end;
end;

procedure TForm1.Form1DOMContentLoaded(Sender: TObject);
begin

  asm

    $(".select-frutas").select2({
              placeholder: "Select an item",
              allowClear: true // Allows you to deselect the selection
          }); 


  end;

end;

end.                   